#!/bin/sh
ESPTOOL=esptool

command -v $ESPTOOL > /dev/null 2>&1 || { echo >&2 "esptool-ck is either not on the path or not installed, please either install it https://github.com/igrr/esptool-ck or update this script to set the ESPTOOL variable to the path for esptool"; exit 1; }

if [ -z "$1" ] 
  then
    echo "No port specified"
    echo "USAGE: $0 <PORT>"
    exit 2
fi

printf "Boot your badge into bootloader mode by holding \"FLASH\" and pressing \"RST\" then press Enter"
read _
echo "Erasing flash"
$ESPTOOL -cp $1 -cd nodemcu -cb 115200 -ce -q
printf "Boot your badge into bootloader mode again by holding \"FLASH\" and pressing \"RST\" then press Enter"
read _
echo "Flashing NodeMCU"
$ESPTOOL -cp $1 -cd nodemcu -cb 115200 -cf nodemcu-master-11-modules-2017-09-03-05-47-38-integer.bin
printf "Reset your badge and press Enter"
read _
$ESPTOOL -cp $1 -cd nodemcu -cb 115200 -cr -q
