#!/bin/sh
UPLOADER=nodemcu-uploader

command -v $UPLOADER > /dev/null 2>&1 || { echo >&2 "nodemcu-uploader is either not on the path or not installed, please either install it https://github.com/kmpm/nodemcu-uploader (It's also in most Debian-like package repos) or update this script to set the UPLOADER variable to the path for nodemcu-uploader"; exit 1; }

if [ -z "$1" ] 
  then
    echo "No port specified"
    echo "USAGE: $0 <PORT>"
    exit 2
fi

echo "Uploading code"
PWD=`pwd`
cd code
nodemcu-uploader --port $1 --baud 115200 upload *
cd $PWD
stty -F $1 speed 115200
echo "Restarting NodeMCU, if you see any errors after this point you may have to manually reset your badge"
echo "node.restart()" > $1
